unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, ComCtrls, ToolWin, ActnMan, ActnCtrls,
  ActnMenus, Buttons, ImgList, Grids;

type
  TForm1 = class(TForm)
    ActionMainMenuBar1: TActionMainMenuBar;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    ImageList1: TImageList;  //bead image list
    DrawGrid1: TDrawGrid;    //design area
    DrawGrid2: TDrawGrid;    //color selector
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DrawGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Tab: Array[0..80, 0..23] Of Integer;

implementation

{$R *.dfm}

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  ImageList1.GetBitmap(Tab[ACol, ARow], bmp);
  DrawGrid1.Canvas.Draw(Rect.Left, Rect.Top, bmp);
  FreeAndNil(bmp);
end;

procedure TForm1.DrawGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var 
 c, d : integer;
begin
 Drawgrid1.MouseToCell(X,Y, c, d);
 Statusbar1.Panels[0].Text:='row ' + inttostr(d) + ', column ' + inttostr(c);
end;

procedure TForm1.DrawGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  ImageList1.GetBitmap(ACol, bmp);
  DrawGrid2.Canvas.Draw(Rect.Left, Rect.Top, bmp);
  FreeAndNil(bmp);
end;

procedure TForm1.DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  Tab[ACol, ARow] := DrawGrid2.Col;
end;

end.
